datablock StaticShapeData(grappleRopeShapeData)
{
	shapeFile = "./rope.dts";
};

datablock StaticShapeData(grappleRopeHookShapeData)
{
	shapeFile = "./hook.dts";
};

datablock AudioProfile(grappleFireSound)
{
	filename	= "./grappleFire.wav";
	description	= AudioClosest3d;
	preload = true;
};

datablock ParticleData(ChainTrailParticle)
{
	dragCoefficient			= 3.0;
	windCoefficient			= 0.0;
	gravityCoefficient		= 0.0;
	inheritedVelFactor		= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS				= 50;
	lifetimeVarianceMS		= 0;
	spinSpeed				= 10.0;
	spinRandomMin			= -50.0;
	spinRandomMax			= 50.0;
	useInvAlpha				= true;
	animateTexture			= false;

	textureName				= "base/data/particles/dot";

	colors[0] = "0.2 0.2 0.2 1";
	colors[1] = "0.2 0.2 0.2 1";
	colors[2] = "0.2 0.2 0.2 1";
	sizes[0]  = 0.15;
	sizes[1]  = 0.15;
	sizes[2]  = 0.15;
	times[0]  = 0.0;
	times[1]  = 0.1;
	times[2]  = 1.0;
};

datablock ParticleEmitterData(ChainTrailEmitter)
{
	ejectionPeriodMS	= 1;
	periodVarianceMS	= 0;
	ejectionVelocity	= 0;
	velocityVariance	= 0;
	ejectionOffset		= 0;
	thetaMin			= 0.0;
	thetaMax			= 90.0;  
	particles			= ChainTrailParticle;
};

datablock ProjectileData(GrappleRopeProjectile)
{
	directDamage		= 0;
	radiusDamage		= 0;
	damageRadius		= 0;

	muzzleVelocity		= 200;
	velInheritFactor	= 1;

	armingDelay			= 0;
	lifetime			= 4000;
	fadeDelay			= 3500;
	bounceElasticity	= 0;
	bounceFriction		= 0;
	isBallistic			= true;
	gravityMod			= 0;

	hasLight			= false;
	lightRadius			= 1.0;
	lightColor			= "0 0 0";
};

datablock ProjectileData(ChainProjectile)
{
	directDamage		= 0;
	radiusDamage		= 0;
	damageRadius		= 0;
	particleEmitter		= ChainTrailEmitter;

	muzzleVelocity		= 200;
	velInheritFactor	= 1;

	armingDelay			= 0;
	lifetime			= 4000;
	fadeDelay			= 3500;
	bounceElasticity	= 0;
	bounceFriction		= 0;
	isBallistic			= true;
	gravityMod			= 0;

	hasLight			= false;
 	lightRadius			= 3.0;
	lightColor			= "0 0 0.5";
};

datablock ItemData(GrappleRopeItem)
{
	category		= "Tool";
	className		= "Tool";

	//shapeFile		= "base/data/shapes/printGun.dts";
	shapeFile		= "./grapplehook.dts";
	mass			= 1;
	density			= 0.2;
	elasticity		= 0.2;
	friction		= 0.6;
	emap			= true;
	
	uiName			= "Grapple Rope";
	iconName		= "./grapple";
	doColorShift	= false; //true
	colorShiftColor	= "1 0.5 0 1";

	image			= GrappleRopeImage;
	canDrop			= true;
};

datablock ShapeBaseImageData(GrappleRopeImage)
{
	//shapeFile			= "base/data/shapes/printGun.dts";
	shapeFile			= "./grapplehook.dts";
	emap				= true;

	mountPoint			= 0;
	offset				= "0.25 0.15 0.1";
	eyeOffset			= "0.5 0.8 -0.4"; 
	eyeRotation			= eulerToMatrix("0 90 0");
	rotation			= eulerToMatrix("0 180 0");
	correctMuzzleVector	= true;
	className			= "WeaponImage";

	item				= GrappleRope;
	ammo				= " ";
	projectile			= GrappleRopeProjectile;
	projectileType		= Projectile;

	melee				= false;
	doRetraction		= false;
	armReady 			= true;

	doColorShift		= false; //true
	colorShiftColor		= "1 0.5 0 1";

	stateName[0]					= "Activate";
	stateTimeoutValue[0]			= 0.2;
	stateTransitionOnTimeout[0]		= "Ready";
	stateScript[0]					= "onRelease";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;

	stateName[2]					= "Fire";
	stateTransitionOnTimeout[2]		= "Hold";
	stateTimeoutValue[2]			= 0.01;
	stateFire[2]					= true;
	stateAllowImageChange[2]		= false;
	stateSequence[2]				= "Fire";
	stateScript[2]					= "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= grappleFireSound;

	stateName[3]					= "Hold";
	stateTimeoutValue[3]			= 0.01;
	stateScript[3]					= "onHold";
	stateTransitionOnTimeout[3]		= "Hold";
	stateTransitionOnTriggerUp[3]	= "Release";

	statename[4]					= "Release";
	stateAllowImageChange[4]		= false;
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "Ready";
	stateScript[4]					= "onRelease";
};

datablock ShapeBaseImageData(GrappleRopeKnifeImage)
{
	shapeFile			= "./grapplehook.dts";
	emap				= true;

	mountPoint			= 1;
	offset				= "0.25 0.15 0.1";
	//eyeOffset			= "0.5 0.8 -0.4"; 
	//eyeRotation			= eulerToMatrix("0 90 0");
	rotation			= eulerToMatrix("0 180 0");
	correctMuzzleVector	= true;
	className			= "WeaponImage";

	item				= GrappleRope;
	ammo				= " ";
	projectile			= GrappleRopeProjectile;
	projectileType		= Projectile;

	melee				= false;
	doRetraction		= false;
	armReady 			= true;

	doColorShift		= false; //true
	colorShiftColor		= "1 0.5 0 1";
};

function GrappleRopeImage::onFire(%this, %obj, %slot)
{
	%proj = %this.projectile;
	
	%pos = %obj.getMuzzlePoint(%slot);
	%muz = %obj.getMuzzleVector(%slot);
	//%objVel = %obj.getVelocity();
	%vec = %muz;
	
	%mask = $TypeMasks::FxBrickObjectType	|
			$TypeMasks::StaticObjectType	|
			$TypeMasks::PlayerObjectType	|
			$TypeMasks::VehicleObjectType	|
			$TypeMasks::TerrainObjectType;
	%ray = containerRayCast(%pos, vectorAdd(%pos, vectorScale(%vec, 1)), %mask, %obj);
	%col = firstWord(%ray);
	if(!isObject(%col))
	{
		%ray = containerRayCast(%pos, vectorAdd(%pos, vectorScale(%vec, 1000)), %mask, %obj, %obj.getObjectMount());
		%col = firstWord(%ray);
		if(!isObject(%col))
			return;
	}
	
	if(%col == groundPlane.getID())
		return;
	
	%hitPos = getWords(%ray, 1, 3);
	
	if(%col.getType() & $TypeMasks::FxBrickObjectType)
		%col.onGrappleHook(%obj.client);
	
	if(isObject(%obj.GrappleHookShape))
		%obj.GrappleHookShape.delete();
	
	%hook = (%obj.GrappleHookShape = new StaticShape()
	{
		datablock = grappleRopeHookShapeData;
	});
	
	%hook.setNodeColor("ALL", "1 1 1 1");
	%hook.setTransform(%hitPos SPC getWords(%obj.getSlotTransform(%slot), 3, 6));
	MissionCleanup.add(%hook);
	
	%hookRopePos = getWords(%hook.getSlotTransform(0), 0, 2);
	%obj.ropeLength = vectorLen(vectorSub(%obj.getPosition(), %hookRopePos));
	%obj.GrappleRopeCol = %col;
	%obj.GrappleRopePos = %hookRopePos;
	%obj.doGrapple = 1;
}

// function GameConnection::AAA(%this)
// {
// 	cancel(%this.AAAS);
// 	if(isObject(%player = %this.player))
// 	{
// 		if(!isObject(%this.hook))
// 		{
// 			%this.hook = new StaticShape()
// 			{
// 				datablock = grappleRopeHookShapeData;
// 				position = "0 0 0";
// 			};
// 		}
		
// 		%eye = %player.getSlotTransform(0);
// 		%this.hook.setTransform(vectorAdd(getWords(%eye, 0, 2), "0 2 0") SPC getWords(%eye, 3, 6));
// 		%this.bottomPrint(%eye);
// 	}
// 	%this.AAAS = %this.schedule(32, "AAA");
// }

function GrappleRopeImage::onHold(%this, %obj, %slot)
{
	if(%obj.doGrapple && %obj.GrappleRopeCol != 0)
	{
		
		if(isObject(%col = %obj.GrappleRopeCol))
		{
			if(%col.getType() & $TypeMasks::FxBrickObjectType && %col.grappleState)
			{
				%this.onRelease(%obj, %slot);
				return;
			}
		}
		
		if(%obj.trigger[4] && %obj.ropeLength >= getWord(%obj.getScale(), 2)*3)
			%obj.ropeLength -= 0.5;
		
		%pos = %obj.GrappleRopePos;
		%ppos = %obj.getPosition();
		
		if(isObject(%mount = %obj.getObjectMount()))
			%vel = %mount.getVelocity();
		else
			%vel = %obj.getVelocity();
		
		if(getWord(%vel, 2) == 0)
		{
			if(vectorDist(%pos, %ppos) > %obj.ropeLength+5)
			{
				if((%image = %obj.getMountedImage(0)) == GrappleRopeImage.getID())
				{
					%image.onRelease(%obj, 0);
					return;
				}
			}
			%vel = vectorAdd(%vel, "0 0 1");
		}
		
		%temp = vectorSub(vectorAdd(%ppos, %vel), %pos);
		
		if(vectorLen(%temp) > %obj.ropeLength)
		{
			%temp2 = vectorSub(vectorAdd(vectorScale(%temp, %obj.ropeLength / vectorLen(%temp)), %pos), %ppos);
			%vel = vectorAdd(vectorScale(%temp2, vectorLen(%vel) / vectorLen(%temp2)), vectorScale(vectorSub(%pos, %ppos), 1 / vectorLen(vectorSub(%pos, %ppos))));
			
			if(%mount)
				%mount.setVelocity(%vel);
			else
				%obj.setVelocity(%vel);
		}

		%a = %obj.GrappleRopePos;
		%b = %obj.getMuzzlePoint(%slot);

		if(isObject(%shape = %obj.GrappleRopeShape))
		{
			%vec1 = vectorNormalize(vectorSub(%a, %b));
			%vec2 = vectorNormalize(vectorSub(%b, %a));

			%xyz = vectorNormalize(vectorCross("1 0 0", %vec1));
			%pow = mACos(vectorDot("1 0 0", %vec1)) * -1;
			%shape.setScale(vectorDist(%a, %b) SPC 0.05 SPC 0.05);
			%position = vectorScale(vectorAdd(%a, %b), 0.5);
			%rotation = %xyz SPC %pow;
			%shape.setTransform(%position SPC %rotation);
		}
		else
		{
			%offset = vectorSub(%a, %b);
			%normal = vectorNormalize(%offset);
			%xyz = vectorNormalize(vectorCross("1 0 0", %normal));
			%pow = (mACos(vectorDot("1 0 0", %normal))*180/3.14159) * -1;
			
			%obj.GrappleRopeShape = new staticShape()
			{
				datablock = grappleRopeShapeData;
				scale = vectorLen(%offset) SPC 0.05 SPC 0.05;
				position = vectorScale(vectorAdd(%a, %b), 0.5);
				rotation = %xyz SPC %pow;
			};
			%obj.GrappleRopeShape.setNodeColor("ALL", "0.2 0.2 0.2 1");
			MissionCleanup.add(%obj.GrappleRopeShape);
		}
	}
	else
		%this.onRelease(%obj, %slot);
}

function GrappleRopeImage::onRelease(%this, %obj, %slot)
{
	if(isObject(%col = %obj.GrappleRopeCol))
	{
		if(%col.getType() & $TypeMasks::FxBrickObjectType)
			%col.onGrappleUnHook(%obj.client);
	}
	
	%obj.ropeLength = 0;
	%obj.GrappleRopeCol = 0;
	%obj.GrappleRopePos = 0;
	%obj.doGrapple = 0;
	//%obj.grappleWraps = 0;

	if(isObject(%obj.GrappleRopeShape))
		%obj.GrappleRopeShape.delete();
	
	if(isObject(%obj.GrappleHookShape))
		%obj.GrappleHookShape.delete();
}

//----------TEST STUFF
// function Player::doGrapple(%this)
// {
// 	%proj = %this.projectile;
	
// 	%pos = %this.getMuzzlePoint(0);
// 	%muz = %this.getMuzzleVector(0);
// 	//%thisVel = %this.getVelocity();
// 	%vec = %muz;
	
// 	%mask = $TypeMasks::FxBrickObjectType	|
// 			$TypeMasks::StaticObjectType	|
// 			$TypeMasks::PlayerObjectType	|
// 			$TypeMasks::VehicleObjectType	|
// 			$TypeMasks::TerrainObjectType;
// 	%ray = containerRayCast(%pos, vectorAdd(%pos, %vec), %mask, %this);
// 	%col = firstWord(%ray);
// 	if(!isObject(%col))
// 	{
// 		%ray = containerRayCast(%pos, vectorAdd(%pos, vectorScale(%vec, 1000)), %mask, %this, %this.getObjectMount());
// 		%col = firstWord(%ray);
// 		if(!isObject(%col))
// 			return;
// 	}
	
// 	if(%col == groundPlane.getID())
// 		return;
	
// 	%hitPos = getWords(%ray, 1, 3);
	
// 	if(%col.getType() & $TypeMasks::FxBrickObjectType)
// 		%col.onGrappleHook(%this.client);

// 	%this.ropeLength = vectorLen(vectorSub(%this.getPosition(), %hitPos));
// 	%this.GrappleRopeCol = %col;
// 	%this.GrappleRopePos = %hitPos;
// 	%this.doGrapple = 1;

// 	%this.grappleTick();
// }

// function Player::grappleTick(%this)
// {
// 	cancel(%this.grappleSched);

// 	if(%this.doGrapple && %this.GrappleRopeCol != 0 && %this.trigger[4])
// 	{
		
// 		if(isObject(%col = %this.GrappleRopeCol))
// 		{
// 			if(%col.getType() & $TypeMasks::FxBrickObjectType && %col.grappleState)
// 			{
// 				%this.stopGrapple();
// 				return;
// 			}
// 		}
		
// 		if(%this.isReeling && %this.ropeLength >= getWord(%this.getScale(), 2)*3)
// 			%this.ropeLength -= 0.5;
		
// 		//GrappleRope(%this, %this.GrappleRopeCol, %this.GrappleRopeTarget, %this.GrappleRopePos);
// 		//		 //(%this, %targetObj, 		   %target, 			   %staticPos, %targetOffset)
		
// 		%pos = %this.GrappleRopePos;
// 		%ppos = %this.getPosition();
		
// 		if(isObject(%mount = %this.getObjectMount()))
// 			%vel = %mount.getVelocity();
// 		else
// 			%vel = %this.getVelocity();
		
// 		if(getWord(%vel, 2) == 0)
// 		{
// 			if(vectorDist(%pos, %ppos) > %this.ropeLength+5)
// 			{
// 				if((%image = %this.getMountedImage(0)) == butterflyKnifeImage.getID())
// 				{
// 					%this.stopGrapple();
// 					return;
// 				}
// 			}
// 			%vel = vectorAdd(%vel, "0 0 1");
// 		}
		
// 		%temp = vectorSub(vectorAdd(%ppos, %vel), %pos);
		
// 		if(vectorLen(%temp) > %this.ropeLength)
// 		{
// 			%temp2 = vectorSub(vectorAdd(vectorScale(%temp, %this.ropeLength / vectorLen(%temp)), %pos), %ppos);
// 			%vel = vectorAdd(vectorScale(%temp2, vectorLen(%vel) / vectorLen(%temp2)), vectorScale(vectorSub(%pos, %ppos), 1 / vectorLen(vectorSub(%pos, %ppos))));
			
// 			if(%mount)
// 				%mount.setVelocity(%vel);
// 			else
// 				%this.setVelocity(%vel);
// 		}

// 		%a = %this.GrappleRopePos;
// 		%b = %this.getMuzzlePoint(%slot);

// 		if(isObject(%shape = %this.GrappleRopeShape))
// 		{
// 			%vec1 = vectorNormalize(vectorSub(%a, %b));
// 			%vec2 = vectorNormalize(vectorSub(%b, %a));

// 			%xyz = vectorNormalize(vectorCross("1 0 0", %vec1));
// 			%pow = mACos(vectorDot("1 0 0", %vec1)) * -1;
// 			%shape.setScale(vectorDist(%a, %b) SPC 0.05 SPC 0.05);
// 			%position = vectorScale(vectorAdd(%a, %b), 0.5);
// 			%rotation = %xyz SPC %pow;
// 			%shape.setTransform(%position SPC %rotation);
// 		}
// 		else
// 		{
// 			%offset = vectorSub(%a, %b);
// 			%normal = vectorNormalize(%offset);
// 			%xyz = vectorNormalize(vectorCross("1 0 0", %normal));
// 			%pow = (mACos(vectorDot("1 0 0", %normal))*180/3.14159) * -1;
			
// 			%this.GrappleRopeShape = new staticShape()
// 			{
// 				datablock = grappleRopeShapeData;
// 				scale = vectorLen(%offset) SPC 0.05 SPC 0.05;
// 				position = vectorScale(vectorAdd(%a, %b), 0.5);
// 				rotation = %xyz SPC %pow;
// 			};
// 			%this.GrappleRopeShape.setNodeColor("ALL", "0.2 0.2 0.2 1");
// 			MissionCleanup.add(%this.GrappleRopeShape);
// 		}

// 		%this.grappleSched = %this.schedule(16, "grappleTick");
// 	}
// 	else
// 		%this.stopGrapple();
// }

// function Player::stopGrapple(%this)
// {
// 	cancel(%this.grappleSched);

// 	if(isObject(%col = %this.GrappleRopeCol))
// 	{
// 		if(%col.getType() & $TypeMasks::FxBrickObjectType)
// 			%col.onGrappleUnHook(%this.client);
// 	}
	
// 	%this.ropeLength = 0;
// 	%this.GrappleRopeCol = 0;
// 	%this.GrappleRopePos = 0;
// 	%this.doGrapple = 0;
// 	//%obj.grappleWraps = 0;

// 	if(isObject(%this.GrappleRopeShape))
// 		%this.GrappleRopeShape.delete();
// }
//--------------

function GrappleRopeImage::onUnMount(%this, %obj, %slot)
{
	%this.onRelease(%obj, %slot);
}

function GrappleRope(%obj, %targetObj, %target, %staticPos, %targetOffset)
{
	if(!isObject(%obj))
		return;
	
	%pos = %staticPos;
	%ppos = %obj.getPosition();
	
	//wrap checking
	//%muzPoint = %obj.getMuzzlePoint(0);
	//%muz = %obj.getMuzzleVector(0);
	
	//%mask = $TypeMasks::FxBrickObjectType	|
	//		$TypeMasks::StaticObjectType	|
	//		$TypeMasks::PlayerObjectType	|
	//		$TypeMasks::VehicleObjectType	|
	//		$TypeMasks::TerrainObjectType;
	//%ray = containerRayCast(%pos, vectorAdd(%pos, vectorScale(%vec, 1000)), %mask, %obj);
	//if(isObject(%col = firstWord(%ray)))
	//{
	//	%hitPos = getWords(%ray, 1, 3);
	//	if(vectorDist())
	//}
	//-------------

	//talk(vectorDist(%pos, %ppos) @" | "@ %obj.ropeLength);	
	if(vectorDist(%pos, %ppos) > %obj.ropeLength+2)
	{
		if((%image = %obj.getMountedImage(0)) == GrappleRopeImage.getID())
			%image.onRelease(%obj, 0);
		return;
	}
	
	%vel = %obj.getVelocity();
	%temp = vectorSub(vectorAdd(%ppos, %vel), %pos);
	
	if(vectorLen(%temp) > %obj.ropeLength)
	{
		%temp2 = vectorSub(vectorAdd(vectorScale(%temp, %obj.ropeLength / vectorLen(%temp)), %pos), %ppos);
		%vel = vectorAdd(vectorScale(%temp2, vectorLen(%vel) / vectorLen(%temp2)), vectorScale(vectorSub(%pos, %ppos), 1 / vectorLen(vectorSub(%pos, %ppos))));
	}
	
	if(isObject(%mount = %obj.getObjectMount()))
		%obj = %mount;
	%obj.setVelocity(%vel);
}

if(isPackage("GrappleRope"))
	deactivatePackage("GrappleRope");
package GrappleRope
{
	function Armor::onTrigger(%this, %obj, %trigger, %val)
	{
		%obj.trigger[%trigger] = %val;

		//if(%obj.client.getBLID() == 25351)
		//{
			// if(%obj.getMountedImage(0) == butterflyKnifeImage.getID())
			// {
			// 	if(%trigger == 4 && %val)
			// 		%obj.doGrapple();
			// 	if(%trigger == 2)
			// 	{
			// 		if(%val)
			// 		{
			// 			if((%time = getSimTime())-%obj.lastJumpTime <= 500)
			// 				%obj.isReeling = 1;
			// 			%obj.lastJumpTime = %time;
			// 		}
			// 		else
			// 			%obj.isReeling = 0;
			// 	}
			// }
		//}
		parent::onTrigger(%this, %obj, %trigger, %val);
	}
	
	function Armor::onRemove(%this, %obj)
	{
		if((%image = %obj.getMountedImage(0)) == GrappleRopeImage.getID())
			%image.onRelease(%obj, 0);
		// else if(%image == butterflyKnifeImage.getID())
		// 	%obj.stopGrapple();
		parent::onRemove(%this, %obj);
	}
	
	function GameConnection::onDeath(%client, %sourceObject, %sourceClient, %damageType, %damLoc)
	{
		if(isObject(%player = %client.player))
		{
			if((%image = %player.getMountedImage(0)) == GrappleRopeImage.getID())
				%image.onRelease(%player, 0);
			// else if(%image == butterflyKnifeImage.getID())
			// 	%player.stopGrapple();
		}
		parent::onDeath(%client, %sourceObject, %sourceClient, %damageType, %damLoc);
	}
};
activatePackage("GrappleRope");

function fxDTSBrick::onGrappleHook(%this, %client)
{
	$InputTarget_Self = %this;
	$InputTarget_Client = %client;
	$InputTarget_Player = %client.player;
	$InputTarget_MiniGame = getMiniGameFromObject(%this);
	
	%this.processInputEvent("onGrappleHook", %client);
}

function fxDTSBrick::onGrappleUnHook(%this, %client)
{
	$InputTarget_Self = %this;
	$InputTarget_Client = %client;
	$InputTarget_Player = %client.player;
	$InputTarget_MiniGame = getMiniGameFromObject(%this);
	
	%this.processInputEvent("onGrappleUnHook", %client);
}

function fxDTSBrick::setGrappleState(%this, %state)
{
	%this.grappleState = !%state;
}

registerInputEvent(fxDTSBrick, "onGrappleHook", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame", 0);
registerInputEvent(fxDTSBrick, "onGrappleUnHook", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame", 0);
registerOutputEvent(fxDTSBrick, "setGrappleState", "bool 0", 1);

function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}
